# This code is provided as supplemental material for the publication of
# "Estimating Transmission Potential of H5N1 Viruses among Humans in
# Egypt Using Phylogeny, Genetic Distance and Sampling Time Interval"
# by Wessam Mohamed, Kimihito Ito, Ryosuke Omori

logl <-function(n,S,p){	
  if(n==0){		
    value = (S-n)*log(1-p);
  }else if(n==S){
    value = n*log(p);
  }else{
    value = n*log(p)+(S-n)*log(1-p);
  }
  return(value);
}

M <-read.csv("candidate_pairs_from_phylogeny.csv",header=TRUE);
dist<-M$genetic_dist
timediff<- M$time_diff
geo_diff<-M$geo_diff

#Threshold values
th_gen<-0.004488
th_tim<-30
th_geo<-0

MF<-M[dist<=th_gen & timediff<=th_tim& geo_diff<=th_geo,]
num_transmission<-length(row.names(MF))
num_seq<-60

#Calculation of R0
R0 <- num_transmission/num_seq;

#Calculation of 95%CI
f <-function(p) -2*(logl(num_transmission,num_seq,p)-logl(num_transmission,num_seq,R0))-3.84;
    
if(R0==0){
    lb=0;
 }else{
    lb=uniroot(f,c(0,R0))$root;
 }
if(R0==1){
    ub=1;
 }else{
    ub=uniroot(f,c(R0,1))$root;
 }
    
print(R0);
print(lb);
print(ub);
